      implicit real*8 (a-h,o-z)

      INCLUDE 'CONSTCOM.'
      INCLUDE 'PDFCOM.'

!  The common to transfer parameters to the Higgs rate code
      COMMON/HIGGSSET/MODE,MODH,MODP

      real*8 termplus(10,0:50,100),termtotplus(10,0:50,100)
     ,      ,termdisp(10,100)

      real*8 hmasses(26)

      data hmasses /9d1, 9.5d1, 1d2, 1.1d2, 1.15d2, 1.2d2, 1.25d2 
     ,   ,1.3d2, 1.35d2, 1.4d2, 1.45d2, 1.5d2, 1.55d2
     ,   ,1.6d2, 1.65d2, 1.7d2, 1.75d2, 1.8d2, 1.85d2, 1.9d2, 2d2
     ,   ,2.2d2, 2.4d2, 2.6d2, 2.8d2, 3d2/ 
 
!  Set up constants, grid spacing, etc.
      call initgridconst
!  The scalar Higgs case
      MODH=1

!  Set up the 5-flavour NNLO PDFs
      kschemepdf=2
      kordpdf=2

      nproc=5                  ! (5 options for the beam type and energy:
                               !  FNAL(1.96 TeV), LHC (7, 8, 10, and 14 TeV)
      npoint=26
      do kpdfset=0,npdftot
!  Fill the PDF grid for the set #kpdfset
        call pdffillgrid
        do kproc=1,nproc
!  Set the beam, target, and the collision energy
          if (kproc.eq.1) then 
!  FNAL, 1.96 TeV
            MODP=2
            sqrts=1960d0 
          end if  
          if (kproc.eq.2) then 
!  LHC, 7 TeV
            MODP=1
            sqrts=7d3
          end if  
          if (kproc.eq.3) then 
!  LHC, 8 TeV
            MODP=1
            sqrts=8d3
          end if  
          if (kproc.eq.4) then 
!  LHC, 10 TeV
            MODP=1
            sqrts=10d3
          end if  
          if (kproc.eq.5) then 
!  LHC, 14 TeV
            MODP=1
            sqrts=14d3
          end if  
          do kpoint=1,npoint
!  Calculate cross section in the order defined by the PDF order 
            termplus(kproc,kpdfset,kpoint)
     =       =higgsnnlorate(hmasses(kpoint),sqrts,kordpdf)
            print *,hmasses(kpoint),termplus(kproc,kpdfset,kpoint)
          end do 
        end do
      end do

      print *,'The NNLO rates of the Higgs boson at the hadron',
     -' colliders (pb) colliders (pb)(first column: Higgs mass (GeV),', 
     -' second column: the rate for FNAL@1.96,', 
     -' third column: the rate for LHC@7,', 
     -' 4-th column: the rate for LHC@8,', 
     -' 5-th column: the rate for LHC@10,', 
     -' 6-th column: the rate for LHC@14)' 

      do kpoint=1,npoint
        do kproc=1,nproc
          termdisp(kproc,kpoint)=0.
          do kpdfset=1,npdftot
            termdisp(kproc,kpoint)=termdisp(kproc,kpoint)
     +      +(termplus(kproc,kpdfset,kpoint)
     -      -termplus(kproc,0,kpoint))**2
          end do
!  In the case of asymmetric PDF errors
!  take average of the positive and negative ones
#if defined(ABKM09) || defined(ABKM09M)
!  Symmetric errors
          termdisp(kproc,kpoint)=sqrt(termdisp(kproc,kpoint))
#else
!  Asymmetric errors stored by pairs
          termdisp(kproc,kpoint)=sqrt(termdisp(kproc,kpoint)/2.)
#endif

        end do
        write (*,fmt='(e13.4,6(e13.4,a2,e10.4))') 
     ,   ,hmasses(kpoint)
     ,   ,(termplus(kk,0,kpoint),'+-',termdisp(kk,kpoint),kk=1,nproc)

      end do

      stop 
      end 
