AC_DEFUN([AC_OC_KERNEL], [

# Sets the compiler/linker gfortran for the files written in F77 standard,
# i.e. with extension .f  
#
AC_PROG_F77([gfortran])
AC_F77_LIBRARY_LDFLAGS

AC_CONFIG_HEADERS([config.h])

# Sets the library g2c, if it is not added by AC_F77_LIBRARY_LDFLAGS, 
# when it is howewer required (for the gcc versions 3.... and earlier)  
#
AC_CHECK_LIB(g2c,main)

# Define paths for the FASTNLOlibrary,
#
LDADD="$LDADD -L\$1/fastnlo -lfastnlo"
# for the QCDRADOPEN library,
#
LDADD="$LDADD -L\$1/qcdlib -lqcdradopen"
# for the shared LHAPDF library (this is necessary for the case 
# when this library is installed in the non-standard place),
#
LDADD="$LDADD -L\$(shell lhapdf-config --libdir) -lLHAPDF"
LDADD="$LDADD -Wl,-rpath,\$(shell lhapdf-config --libdir)"
# and for the CERN libraries
#
if test "x$with_usercern" != x""; then 
LDADD="$LDADD -L$with_usercern -lmathlib -lpacklib" ;else
LDADD="$LDADD -L/cern/pro/lib -lmathlib -lpacklib"
fi
AC_SUBST(LDADD)

# Sets the compilation options for the F77 standard files 
#
AM_FFLAGS="$AM_FFLAGS -O4 -ffixed-line-length-132 -I\$1/includes"
AC_SUBST(AM_FFLAGS)

AM_CPPFLAGS="$AM_CPPFLAGS -D\$(PDFSET)"
AC_SUBST(AM_CPPFLAGS)

# Sets the ranlib utility to produce index of the created libraries 
AC_PROG_RANLIB

# Define the path to the LHAPDF grids
#
LHAPATH="\$(shell lhapdf-config --datadir)/PDFsets/"
AC_SUBST(LHAPATH)

# Define the path to the QCDRADOPEN grids 
#
GRIDS="\$1/grids/"
AC_SUBST(GRIDS)

])
