C-----------------
      SUBROUTINE PDFFILLGRID
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'APSCOM6.'
      include 'CONSTCOM.'
      INCLUDE 'PDFCOM.'

      real*8 fsp(nxtot),bs(nxtot),cs(nxtot),ds(nxtot),xx(nxtot)
      real*8 pdfs(0:8),dpdfs(0:8,27)

      character name*80
      real*8 f(-6:6)
      data kpdfset /0/

!  Setup of the PDF grid

      smax=log(log(q2max/0.04)/log(q2ini/0.04))
      smin=-log(log(q2min/0.04)/log(q2ini/0.04))
      dels1=smax/nspgrid
      dels2=smin/nsmgrid
      xlog0=log(xbmin)
      delx2=-(xlog0-xlog1)/nxmgrid

      xmax=0.99d0
      delx3=(log(1-xmax)-log(1-x1))/(nxpgrid-1)

! Mapping with log(1-x) at large x
      do i=0,nxpgrid-1
        xgrid(i)=1-exp(log(1-xmax)+delx3*(i-nxpgrid+1))
      end do
      xgrid(nxpgrid)=1.

! Mapping with log(x) at small x
      do i=-nxmgrid,0
        xgrid(i)=exp(xlog1+delx2*i)
      end do

      DO I=0,nspgrid
        SGRID(I)=DELS1*I
      END DO

      DO I=-nsmgrid,0
        SGRID(I)=DELS2*I
      END DO

!  Here we fill the PDFs grid to be used elsewhere

!  Select the PDF set from the LHAPDF library

      name=' '
#ifdef ABM11
      if (kschemepdf.eq.2) then 
!        if (kordpdf.eq.2) name='abkm09_5_nnlo.LHgrid'    
        if (kordpdf.eq.1) name='abm11_5_nlo.LHgrid'    
      end if
!      if (kschemepdf.eq.1) then 
!        if (kordpdf.eq.2) name='abkm09_4_nnlo.LHgrid'    
!        if (kordpdf.eq.1) name='abkm09_4_nlo.LHgrid'    
!      end if
      if (kschemepdf.eq.0) then 
!        if (kordpdf.eq.2) name='abkm09_3_nnlo.LHgrid'    
        if (kordpdf.eq.1) name='abm11_3_nlo.LHgrid'    
      end if
#endif 
#ifdef ABKM09
      if (kschemepdf.eq.2) then 
        if (kordpdf.eq.2) name='abkm09_5_nnlo.LHgrid'    
        if (kordpdf.eq.1) name='abkm09_5_nlo.LHgrid'    
      end if
      if (kschemepdf.eq.1) then 
        if (kordpdf.eq.2) name='abkm09_4_nnlo.LHgrid'    
        if (kordpdf.eq.1) name='abkm09_4_nlo.LHgrid'    
      end if
      if (kschemepdf.eq.0) then 
        if (kordpdf.eq.2) name='abkm09_3_nnlo.LHgrid'    
        if (kordpdf.eq.1) name='abkm09_3_nlo.LHgrid'    
      end if
#endif 
#ifdef JR09
      if (kordpdf.eq.2) then
        if (kschemepdf.eq.2) name='JR09VFnnloE.LHgrid'    
        if (kschemepdf.eq.1) name='JR09VFnnloE.LHgrid'    
        if (kschemepdf.eq.0) name='JR09FFnnloE.LHgrid'    
      end if
#endif
#ifdef CT10
      if (kordpdf.eq.1) then 
        if (kschemepdf.eq.2) name='CT10.LHgrid'    
        if (kschemepdf.eq.1) name='CT10f4.LHgrid'   
        if (kschemepdf.eq.0) name='CT10f3.LHgrid'    
      end if
#endif
#ifdef NN21
      if (kordpdf.eq.1) then
        if (kschemepdf.eq.2) name='NNPDF21_FFN_NF5_100.LHgrid'
        if (kschemepdf.eq.1) name='NNPDF21_FFN_NF4_100.LHgrid'
        if (kschemepdf.eq.0) name='NNPDF21_FFN_NF3_100.LHgrid'
      end if
#endif
#ifdef MSTW08
      if (kschemepdf.eq.2) then 
        if (kordpdf.eq.2) name='MSTW2008nnlo68cl.LHgrid'    
        if (kordpdf.eq.1) name='MSTW2008nlo68cl.LHgrid'    
      end if
      if (kschemepdf.eq.1) then 
        if (kordpdf.eq.2) name='MSTW2008nnlo68cl_nf4.LHgrid'    
        if (kordpdf.eq.1) name='MSTW2008nlo68cl_nf4.LHgrid'    
      end if
      if (kschemepdf.eq.0) then 
        if (kordpdf.eq.2) name='MSTW2008nnlo68cl_nf3.LHgrid'    
        if (kordpdf.eq.1) name='MSTW2008nlo68cl_nf3.LHgrid'    
      end if
#endif
#ifdef HERAPDF1
      if (kschemepdf.eq.2) then 
        if (kordpdf.eq.1) name='HERAPDF10_EIG.LHgrid'
      end if
#endif
!  The NNLO toy LH PDFs 
#ifdef TOYLH
      CALL GETENV( 'GRIDS', name ) 
      name=name(:LNBLNK(name))//'pdfs/toylh/toyLH_NNLO_nf3.grid'
      call InitNNPDFwrap(name,NREP)
      call InitPDF(kpdfset)
#endif

! Set the PDF set for the case of LHAPDF interface  
#if defined(MSTW08)||defined(JR09)||defined(HERAPDF1)||defined(ABKM09)||defined(ABM11)||defined(CT10)||defined(NN21)  
      if (name.eq.' ') then 
        print *,'WARNING: the PDF set requested is not available'
        stop
      else
        call initPDFSetByName(name)
        call InitPDF(kpdfset)
      end if
#endif

! ...then fill the PDF grid....

      DO is=-nsmgrid,nspgrid
        q2=exp(exp(sgrid(is))*log(q2ini/0.04))*0.04
        DO IX=-nxmgrid,nxpgrid
          xb=xgrid(ix)

#ifdef ABKM09M
! The special case of the ABKM grid interface
           call a09m(xb,q2,pdfs,dpdfs,kschemepdf+3,kpdfset,kordpdf)
c  \alpha_s
           if (kpdfset.ne.0) then   
             Y(kschemepdf,0,IX,is)=pdfs(0)+dpdfs(0,kpdfset)
           else  
             Y(kschemepdf,0,IX,is)=pdfs(0)
           end if 
c  gluon
           if (kpdfset.ne.0) then   
             Y(kschemepdf,1,IX,is)=pdfs(3)+dpdfs(3,kpdfset)
           else  
             Y(kschemepdf,1,IX,is)=pdfs(3)
           end if 
c  d
           if (kpdfset.ne.0) then   
             Y(kschemepdf,2,IX,is)=pdfs(2)+pdfs(6)
     +                   +dpdfs(2,kpdfset)+dpdfs(6,kpdfset)
           else  
             Y(kschemepdf,2,IX,is)=pdfs(2)+pdfs(6)
           end if
c  dbar
           if (kpdfset.ne.0) then   
             Y(kschemepdf,3,IX,is)=pdfs(6)+dpdfs(6,kpdfset)
           else  
             Y(kschemepdf,3,IX,is)=pdfs(6)
           end if
c  u
           if (kpdfset.ne.0) then   
             Y(kschemepdf,4,IX,is)=pdfs(1)+pdfs(4)
     +                   +dpdfs(1,kpdfset)+dpdfs(4,kpdfset)
           else  
             Y(kschemepdf,4,IX,is)=pdfs(1)+pdfs(4)
           end if
c  ubar
           if (kpdfset.ne.0) then   
             Y(kschemepdf,5,IX,is)=pdfs(4)+dpdfs(4,kpdfset)
           else  
             Y(kschemepdf,5,IX,is)=pdfs(4)
           end if
c  s,sbar
           if (kpdfset.ne.0) then   
             Y(kschemepdf,6,IX,is)=pdfs(5)+dpdfs(5,kpdfset)
           else  
             Y(kschemepdf,6,IX,is)=pdfs(5)
           end if
           Y(kschemepdf,7,IX,is)=Y(kschemepdf,6,IX,is)
c  c,cbar
           if (kschemepdf.ge.1) then 
             if (kpdfset.ne.0) then   
               Y(kschemepdf,8,IX,is)=pdfs(7)+dpdfs(7,kpdfset)
             else  
               Y(kschemepdf,8,IX,is)=pdfs(7)
             end if
             Y(kschemepdf,9,IX,is)=Y(kschemepdf,8,IX,is)
           end if 
c  b,bbar
           if (kschemepdf.ge.2) then 
             if (kpdfset.ne.0) then   
               Y(kschemepdf,10,IX,is)=pdfs(8)+dpdfs(8,kpdfset)
             else  
               Y(kschemepdf,10,IX,is)=pdfs(8)
             end if
             Y(kschemepdf,11,IX,is)=Y(kschemepdf,8,IX,is)
           end if
#endif
#if defined(MSTW08)||defined(JR09)||defined(HERAPDF1)||defined(ABKM09)||defined(ABM11)||defined(CT10)||defined(NN21)||defined(TOYLH)  
! LHAPDF interface
#ifdef TOYLH
! A special case for the toy LH PDFs
           call NNPDFINTevolveLHA(xb,sqrt(q2),f,1)
           q20alphas=rmass(8)**2
           alphas0=0.35d0
           an=alphas_ffn(q2)
#else
           an=alphasPDF(sqrt(q2))
#endif
c  \alpha_s  
           Y(kschemepdf,0,IX,is)=an
c  PDFs
           call evolvePDF(xb,sqrt(q2),f)
c  gluon
           Y(kschemepdf,1,IX,is)=f(0)
c  d
           Y(kschemepdf,2,IX,is)=f(1)
c  dbar
           Y(kschemepdf,3,IX,is)=f(-1)
c  u
           Y(kschemepdf,4,IX,is)=f(2)
c  ubar
           Y(kschemepdf,5,IX,is)=f(-2)
c  s,sbar
           Y(kschemepdf,6,IX,is)=f(3)
           Y(kschemepdf,7,IX,is)=f(-3)
           Y(kschemepdf,8,IX,is)=0.
           Y(kschemepdf,9,IX,is)=0.
           Y(kschemepdf,10,IX,is)=0.
           Y(kschemepdf,11,IX,is)=0.
c  c,cbar
           if (kschemepdf.ge.1) then 
             Y(kschemepdf,8,IX,is)=f(-4)
             Y(kschemepdf,9,IX,is)=f(-4)
             Y(kschemepdf,10,IX,is)=0.
             Y(kschemepdf,11,IX,is)=0.
           end if
c  b,bbar
           if (kschemepdf.ge.2) then 
             Y(kschemepdf,10,IX,is)=f(-5)
             Y(kschemepdf,11,IX,is)=f(-5)
           end if
#endif
#ifdef USER
! A user PDF input
c  \alpha_s  
           Y(kschemepdf,0,IX,is)=useralphas(q2
     ,           ,kschemepdf,kordpdf,kpdfset)
c  gluon
           Y(kschemepdf,1,IX,is)=userpdfs(xb,q2,0
     ,           ,kschemepdf,kordpdf,kpdfset)
c  d
           Y(kschemepdf,2,IX,is)=userpdfs(xb,q2,1
     ,           ,kschemepdf,kordpdf,kpdfset)
c  dbar
           Y(kschemepdf,3,IX,is)=userpdfs(xb,q2,-1
     ,           ,kschemepdf,kordpdf,kpdfset)
c  u
           Y(kschemepdf,4,IX,is)=userpdfs(xb,q2,2
     ,           ,kschemepdf,kordpdf,kpdfset)
c  ubar
           Y(kschemepdf,5,IX,is)=userpdfs(xb,q2,-2
     ,           ,kschemepdf,kordpdf,kpdfset)
c  s,sbar
           Y(kschemepdf,6,IX,is)=userpdfs(xb,q2,3
     ,           ,kschemepdf,kordpdf,kpdfset)
           Y(kschemepdf,7,IX,is)=userpdfs(xb,q2,-3
     ,           ,kschemepdf,kordpdf,kpdfset)
           Y(kschemepdf,8,IX,is)=0.
           Y(kschemepdf,9,IX,is)=0.
           Y(kschemepdf,10,IX,is)=0.
           Y(kschemepdf,11,IX,is)=0.
c  c,cbar
           if (kschemepdf.ge.1) then 
             Y(kschemepdf,8,IX,is)=userpdfs(xb,q2,-4
     ,           ,kschemepdf,kordpdf,kpdfset)
             Y(kschemepdf,9,IX,is)=userpdfs(xb,q2,-4
     ,           ,kschemepdf,kordpdf,kpdfset)
             Y(kschemepdf,10,IX,is)=0.
             Y(kschemepdf,11,IX,is)=0.
           end if
c  b,bbar
           if (kschemepdf.ge.2) then 
             Y(kschemepdf,10,IX,is)=userpdfs(xb,q2,-5
     ,           ,kschemepdf,kordpdf,kpdfset)
             Y(kschemepdf,11,IX,is)=userpdfs(xb,q2,-5
     ,          ,kschemepdf,kordpdf,kpdfset)
           end if
#endif
        end do

! ...and finally, construct the spline interpolation coefficients for the grid.
        do iq=0,7+kschemepdf*2
          do ix=-nxmgrid,nxpgrid
            xx(ix+nxmgrid+1)=xgrid(ix)
            fsp(ix+nxmgrid+1)=y(kschemepdf,iq,ix,is)
          end do
          call spline (nxmgrid+nxpgrid+1,xx,fsp,bs,cs,ds)
          do ix=-nxmgrid,nxpgrid
              bcoeff(kschemepdf,iq,ix,is)=bs(ix+nxmgrid+1)
              ccoeff(kschemepdf,iq,ix,is)=cs(ix+nxmgrid+1)
              dcoeff(kschemepdf,iq,ix,is)=ds(ix+nxmgrid+1)
          end do
        end do
      end do

      RETURN
      END
C------------------
      real*8 function XQGX1(k,iq,XB,IS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'APSCOM6.'

      data xbsave /-1d0/

      save xbsave,ix,aa

      if (xb.ne.xbsave) then 
        do ix=-nxmgrid,nxpgrid
          if (xb.lt.xgrid(ix+1)) goto 300
        end do
 300    xbsav=xb
      end if

      aa=xb-xgrid(ix)

      xqgx1=y(k,iq,ix,is)+aa*bcoeff(k,iq,ix,is)
     +     +aa**2*ccoeff(k,iq,ix,is)+aa**3*dcoeff(k,iq,ix,is)

      RETURN
      END
C------------------
      REAL*8 FUNCTION XQG(IQ,xx,Q2,kp)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INCLUDE 'APSCOM6.'

      DATA Q2SAV/-1./
      data xbsav/-1./
      save xbsav,q2sav,is,q,ix,p

      xb=min(xx,xbmax)

      if(q2.gt.q2max.or.q2.lt.q2min)
     -            print*,'q2 out of range in xqg:',q2,q2min,q2max
      s=log(log(q2/0.04)/log(q2ini/0.04))
      if (s.ge.0.) then
        is=int(s/dels1)
        dss=(s-sgrid(is))/dels1
      else
        is=int(s/dels2)-1
        dss=(s-sgrid(is))/dels2
      end if
      q=(s-sgrid(is))/(sgrid(is+1)-sgrid(is))

      if(xb.ne.xbsav) then 
        if (xb.gt.1..or.xb.lt.xbmin)
     -              print *,'xb out of range in xqg:',xb

        do ix=-nxmgrid,nxpgrid
          if (xb.lt.xgrid(ix+1)) goto 300
        end do
 300  xbsav=xb
      end if

      aa=xb-xgrid(ix)

      if(is.ne.-nsmgrid.and.ix.ne.-nxmgrid) then 
        f0=y(kp,iq,ix,is)+aa*bcoeff(kp,iq,ix,is)
     +    +aa**2*ccoeff(kp,iq,ix,is)+aa**3*dcoeff(kp,iq,ix,is)
        fp=y(kp,iq,ix,is+1)+aa*bcoeff(kp,iq,ix,is+1)
     +    +aa**2*ccoeff(kp,iq,ix,is+1)+aa**3*dcoeff(kp,iq,ix,is+1)
        fm=y(kp,iq,ix,is-1)+aa*bcoeff(kp,iq,ix,is-1)
     +    +aa**2*ccoeff(kp,iq,ix,is-1)+aa**3*dcoeff(kp,iq,ix,is-1)
        xqg=fm*q*(q-1d0)/2d0 + f0*(1d0-q**2) + fp*q*(q+1d0)/2d0
      else
        f0=y(kp,iq,ix,is)+aa*bcoeff(kp,iq,ix,is)
     +    +aa**2*ccoeff(kp,iq,ix,is)+aa**3*dcoeff(kp,iq,ix,is)
        fp=y(kp,iq,ix,is+1)+aa*bcoeff(kp,iq,ix,is+1)
     +    +aa**2*ccoeff(kp,iq,ix,is+1)+aa**3*dcoeff(kp,iq,ix,is+1)
        xqg=f0*(1d0-q) + fp*q
      end if

      RETURN
      END
!------------------
      real*8 function xqgn(iq,xb,q2,kp)
      implicit double precision (a-h,o-z)

!  The neutron PDFs

      k=iq
      if (iq.eq.2) k=4
      if (iq.eq.3) k=5
      if (iq.eq.4) k=2
      if (iq.eq.5) k=3

      xqgn=xqg(k,xb,q2,kp)

      RETURN
      END
